package semafori;
/**
 * Classe che implementa i metodi del semaforo
 *
 * @author Boschi Alessandro
 * @author Fabrizi Andrea
 * @author Ronchi Alessandro
 * @author Scozzoli Angelo
 */

public class Semaforo
{
    private int value;
    
    /**
     * Costruttore della classe
     * @param val numero diu accessi consentiti dal semaforo
     */
    
    public Semaforo(int val)
    {
	value=val;
    }
    
    public synchronized void P()
    {
	while (value<=0){
	    try
		{
		    wait();
		}
	    catch(InterruptedException e){}
	}
	value--;
    }
    
    public synchronized void V()
    {
	value++;
	notify();
    }
    
}
