package semafori;
/**
 * Classe del thread utente
 *
 * @author Boschi Alessandro
 * @author Fabrizi Andrea
 * @author Ronchi Alessandro
 * @author Scozzoli Angelo
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * La classe persona contiene tutte le informazioni che servono all'applet
 * per graficarla.
 * Alcune di queste vengono inizializzate in modo random.
 */

public class persona extends Thread
{

    public int direzione, girato, Width, Height, xpartenza, x, id_asc, usr_img;
    public String imagefile;
    public JLabel PersonaLabel, TextLabel;
    public Image Immagine;
    public ImageIcon PersonaIcon;
    public boolean free;
    public Semaforo_asc sem;
    public int piano_from;
    public int piano_to;
    public int id;
    public int verso;
    public boolean muovi;
    public Semaforo disegna = new Semaforo(0);

    /**
     * Costruttore della classe persona.
     * Qu viene associato all'id della persona il file contenete l'immagine che
     * l'applet dovr graficare; nonch la posizione iniziale sul piano, e il piano di destinazione
     * Qu viene anche creati il pannello su cui verr disegnata l'immagine.
     * @param sg Semaforo globale.
     * @param n_piani il numero di piani del palazzo (necessario per la generazione random)
     * @param usr_id id di riconoscimento dell'utente.
     */

    public persona(int n_piani, Semaforo_asc sg,int usr_id,int pf,int direz)
    {
	girato=((int) (Math.random() * 2));
	xpartenza= (((int) (Math.random()*293))+190);
        usr_img=((int) (Math.random() * 20)+1);
	imagefile=("pass"+ usr_img +"_"+girato+".gif");
	x=xpartenza;
	muovi=false;
	direzione=direz;
	sem=sg;
	id=usr_id;
	id_asc=0;
	piano_from=pf;
	if (direzione==1)
	    piano_to= (int) (Math.random() * piano_from);
	else
	    piano_to= ((int) (Math.random() * ((n_piani-piano_from)-1))+(piano_from+1));

	TextLabel = new JLabel();
	TextLabel.setText(String.valueOf(piano_to));
	TextLabel.setBounds(-10, -10, 10, 10);
	Font font1 = new Font("Verdana", Font.PLAIN, 10);
	TextLabel.setFont(font1);
    }

    public void run()
    {
	sem.usr_init(this);
	sem.usr_enter(this);
    }

}
